// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2020-01-20T15:09:01, by ESR Version 2.2.0.58 using ESR Database SWS_EA_ESR_Cloud_Prod
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using Ato.EN.IntegrationServices.Document.DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationPMTPLNSUB
{

    public partial class PMTPLNSUBRequest2020Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="PMTPLNSUBRequest2020Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public PMTPLNSUBRequest2020Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString().ToLower() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(string val)
        {
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(decimal? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(int? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

         /// <summary>
         /// Get string value between [first] a and [last] b.
         /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

         /// <summary>
         /// Get string value after [first] a.
         /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

         /// <summary>
         /// Get string value after [last] a.
         /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
            return 0;
            else
            return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return (from x in nodes select x).Distinct().Count() != 1;
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
           if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

        public DateTime Date(DateTime? datetime)
        {                   
            return datetime.GetValueOrDefault().Date;
        }

				//The logic in After function expects "---" for day and "--" for month. 
				//Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
					return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response = true;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length == 14)
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 3), out numeric))
                        response = false;

                }
                else if (usi.Length == 9)
                {

                    if (Regex.IsMatch(usi, @"^([a-zA-Z]{3}\d{4}[a-zA-Z]{2})$"))
                        response = false;
                }
            }
            return response;
        }

        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
             return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
             decimal numberValue;
             decimal.TryParse(value, out numberValue);
             return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':                        
                        options = options | RegexOptions.IgnoreCase;                       
                        break;
                    case 'm':                        
                        options = options | RegexOptions.Multiline;                       
                        break;
                    case 's':                        
                            options = options | RegexOptions.Singleline;                       
                        break;
                    case 'n':                        
                            options = options | RegexOptions.ExplicitCapture;                       
                        break;
                    case 'x':                       
                            options = options | RegexOptions.IgnorePatternWhitespace;                       
                        break;
                }
            }

            return options;
        }

        private static string Substring(object field, int start, int length)
        {
            return field.ToString().Substring(start, length);
        }
        
        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public PMTPLNSUBRequest2020 ConsumedReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string,ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(PMTPLNSUBRequest2020 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

    
            #region VR.ATO.PMTPLN.000001
    
            /*  VR.ATO.PMTPLN.000001
            At least one of Account identifier and Account sequence number must be supplied.
    
            Legacy Rule Format:
            (^PMTPLN11 = NULL) AND (^PMTPLN12 = NULL)

            Technical Business Rule Format:
            (^PMTPLN11 = NULL) AND (^PMTPLN12 = NULL)
    
            Data Elements:
    
            ^PMTPLN11 = PMTPLNSUB:RP:PaymentPlan:Tax.Account.Identifier
    
            ^PMTPLN12 = PMTPLNSUB:RP:PaymentPlan:Tax.AccountSequence.Number
            */
            assertion = (report.PMTPLN11 == null && report.PMTPLN12 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000001", Severity = ProcessMessageSeverity.Error,
                    Description = @"Account identifier and Account sequence number not provided.",
                    LongDescription = @"At least one of Account identifier and Account sequence number must be provided.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:TaxAccountId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000001"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN11", Value = GetValueOrEmpty(report.PMTPLN11) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN12", Value = report.PMTPLN12.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000001
    
            #region VR.ATO.PMTPLN.000002
    
            /*  VR.ATO.PMTPLN.000002
            Where an Instalment frequency of LumpSum is supplied, the Upfront payment amount must equal the Payment plan amount.
    
            Legacy Rule Format:
            (^PMTPLN22 = 'LumpSum') AND (^PMTPLN17 <> ^PMTPLN18)

            Technical Business Rule Format:
            (^PMTPLN22 = 'LumpSum') AND (^PMTPLN17 <> ^PMTPLN18)
    
            Data Elements:
    
            ^PMTPLN17 = PMTPLNSUB:RP:PaymentPlan:PaymentArrangement.UpfrontPayment.Amount
    
            ^PMTPLN18 = PMTPLNSUB:RP:PaymentPlan:PaymentArrangement.Total.Amount
    
            ^PMTPLN22 = PMTPLNSUB:RP:PaymentPlan:PaymentArrangement.PaymentFrequency.Code
            */
            assertion = (report.PMTPLN22 == @"LumpSum" && report.PMTPLN17.GetValueOrDefault() != report.PMTPLN18.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000002", Severity = ProcessMessageSeverity.Error,
                    Description = @"Upfront payment amount does not equal the Payment plan amount.",
                    LongDescription = @"Where an Instalment frequency of ""LumpSum"" is supplied, the Upfront payment amount must equal the Payment plan amount.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:PaymentArrangementUpfrontPaymentA",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000002"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN22", Value = report.PMTPLN22 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN17", Value = GetValueOrEmpty(report.PMTPLN17) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN18", Value = GetValueOrEmpty(report.PMTPLN18) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000002
    
            #region VR.ATO.PMTPLN.000003
    
            /*  VR.ATO.PMTPLN.000003
            Payment plan amount must equal either Tax account balance or Debt due amount.
    
            Legacy Rule Format:
            (^PMTPLN18 <> ^PMTPLN19) AND (^PMTPLN18 <> ^PMTPLN20)

            Technical Business Rule Format:
            (^PMTPLN18 <> ^PMTPLN19) AND (^PMTPLN18 <> ^PMTPLN20)
    
            Data Elements:
    
            ^PMTPLN18 = PMTPLNSUB:RP:PaymentPlan:PaymentArrangement.Total.Amount
    
            ^PMTPLN19 = PMTPLNSUB:RP:PaymentPlan:Tax.AccountBalance.Amount
    
            ^PMTPLN20 = PMTPLNSUB:RP:PaymentPlan:Tax.LiabilityDue.Amount
            */
            assertion = (report.PMTPLN18.GetValueOrDefault() != report.PMTPLN19.GetValueOrDefault() && report.PMTPLN18.GetValueOrDefault() != report.PMTPLN20.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000003", Severity = ProcessMessageSeverity.Error,
                    Description = @"Payment plan amount does not equal either Tax account balance or Debt due amount.",
                    LongDescription = @"Payment plan amount must equal either Tax account balance or Debt due amount. Payment plans may only be applied for one of these balances.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:PaymentArrangementTotalA",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000003"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN18", Value = GetValueOrEmpty(report.PMTPLN18) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN19", Value = GetValueOrEmpty(report.PMTPLN19) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN20", Value = GetValueOrEmpty(report.PMTPLN20) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000003
    
            #region VR.ATO.PMTPLN.000004
    
            /*  VR.ATO.PMTPLN.000004
            At least one of Tax account balance and Debt due amount must be provided.
    
            Legacy Rule Format:
            (^PMTPLN19 = NULL) AND (^PMTPLN20 = NULL)

            Technical Business Rule Format:
            (^PMTPLN19 = NULL) AND (^PMTPLN20 = NULL)
    
            Data Elements:
    
            ^PMTPLN19 = PMTPLNSUB:RP:PaymentPlan:Tax.AccountBalance.Amount
    
            ^PMTPLN20 = PMTPLNSUB:RP:PaymentPlan:Tax.LiabilityDue.Amount
            */
            assertion = (report.PMTPLN19 == null && report.PMTPLN20 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000004", Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax account balance and Debt due amount not provided.",
                    LongDescription = @"At least one of Tax account balance and Debt due amount must be provided.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:TaxAccountBalanceA",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000004"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN19", Value = GetValueOrEmpty(report.PMTPLN19) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN20", Value = GetValueOrEmpty(report.PMTPLN20) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000004
    
            #region VR.ATO.PMTPLN.000005
    
            /*  VR.ATO.PMTPLN.000005
            Where a Payment method of DirectDebit is supplied, then Account BSB, Account number and Account name must be provided.
    
            Legacy Rule Format:
            (^PMTPLN23 = 'DirectDebit') AND ((^PMTPLN24 = NULL) OR (^PMTPLN25 = NULL) OR (^PMTPLN26 = NULL))

            Technical Business Rule Format:
            (^PMTPLN23 = 'DirectDebit') AND ((^PMTPLN24 = NULL) OR (^PMTPLN25 = NULL) OR (^PMTPLN26 = NULL))
    
            Data Elements:
    
            ^PMTPLN24 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.BankStateBranch.Number
    
            ^PMTPLN23 = PMTPLNSUB:RP:PaymentPlan:PaymentMechanism.PaymentMethod.Code
    
            ^PMTPLN25 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
    
            ^PMTPLN26 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = (report.PMTPLN23 == @"DirectDebit" && (report.PMTPLN24 == null || report.PMTPLN25 == null || report.PMTPLN26 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000005", Severity = ProcessMessageSeverity.Error,
                    Description = @"BSB number, Account number and Account name must all be present.",
                    LongDescription = @"Where a Payment Method of ""DirectDebit"" is supplied, then Account BSB, Account number and Account name must be provided.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:FinancialInstitutionAccountBankStateBranchN",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000005"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN23", Value = report.PMTPLN23 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN24", Value = GetValueOrEmpty(report.PMTPLN24) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN25", Value = GetValueOrEmpty(report.PMTPLN25) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN26", Value = GetValueOrEmpty(report.PMTPLN26) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000005
    
            #region VR.ATO.PMTPLN.000006
    
            /*  VR.ATO.PMTPLN.000006
            If at least one of Account BSB, Account number and Account name have been provided, then all of these fields must be provided.
    
            Legacy Rule Format:
            ((^PMTPLN24 <> NULL) OR (^PMTPLN25 <> NULL) OR (^PMTPLN26 <> NULL)) AND ((^PMTPLN24 = NULL) OR (^PMTPLN25 = NULL) OR (^PMTPLN26 = NULL))

            Technical Business Rule Format:
            ((^PMTPLN24 <> NULL) OR (^PMTPLN25 <> NULL) OR (^PMTPLN26 <> NULL)) AND ((^PMTPLN24 = NULL) OR (^PMTPLN25 = NULL) OR (^PMTPLN26 = NULL))
    
            Data Elements:
    
            ^PMTPLN24 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.BankStateBranch.Number
    
            ^PMTPLN25 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
    
            ^PMTPLN26 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = ((report.PMTPLN24 != null || report.PMTPLN25 != null || report.PMTPLN26 != null) && (report.PMTPLN24 == null || report.PMTPLN25 == null || report.PMTPLN26 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000006", Severity = ProcessMessageSeverity.Error,
                    Description = @"BSB number, Account number and Account name must all be present.",
                    LongDescription = @"If at least one of Account BSB, Account number and Account name have been provided, then all of these fields must be provided.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:FinancialInstitutionAccountBankStateBranchN",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000006"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN24", Value = GetValueOrEmpty(report.PMTPLN24) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN25", Value = GetValueOrEmpty(report.PMTPLN25) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN26", Value = GetValueOrEmpty(report.PMTPLN26) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000006
    
            #region VR.ATO.PMTPLN.000007
    
            /*  VR.ATO.PMTPLN.000007
            Value must consist of a number greater than 012000.
    
            Legacy Rule Format:
            (^PMTPLN24 <> BLANK) AND (AsNumeric(^PMTPLN24) < 12001 OR AsNumeric(^PMTPLN24) > 999999)

            Technical Business Rule Format:
            (^PMTPLN24 <> BLANK) AND (AsNumeric(^PMTPLN24) < 12001 OR AsNumeric(^PMTPLN24) > 999999)
    
            Data Elements:
    
            ^PMTPLN24 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.BankStateBranch.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.PMTPLN24) != true && (AsNumeric(report.PMTPLN24) < 12001 || AsNumeric(report.PMTPLN24) > 999999));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000007", Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Account BSB provided.",
                    LongDescription = @"Account BSB must be a numeric value greater than 012000.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:FinancialInstitutionAccountBankStateBranchN",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000007"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN24", Value = GetValueOrEmpty(report.PMTPLN24) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000007
    
            #region VR.ATO.PMTPLN.000008
    
            /*  VR.ATO.PMTPLN.000008
            The account name is preceded by a space, or contains only a space. Remove all leading spaces.
    
            Legacy Rule Format:
            StartsWith(^PMTPLN26, ' ')

            Technical Business Rule Format:
            StartsWith(^PMTPLN26, ' ')
    
            Data Elements:
    
            ^PMTPLN26 = PMTPLNSUB:RP:PaymentPlan:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = IsMatch(report.PMTPLN26, @"^( )",RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000008", Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Account name provided.",
                    LongDescription = @"The account name is preceded by a space, or contains only a space. Remove all leading spaces.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:FinancialInstitutionAccountFinancialInstitutionAccountNameT",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000008"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN26", Value = GetValueOrEmpty(report.PMTPLN26) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000008
    
            #region VR.ATO.PMTPLN.000013
    
            /*  VR.ATO.PMTPLN.000013
            If provided, Intermediary Signature Indicator must be 'TRUE'
    
            Legacy Rule Format:
            (^PMTPLN311 <> NULL) AND (^PMTPLN3 <> TRUE)

            Technical Business Rule Format:
            (^PMTPLN311 <> NULL) AND (^PMTPLN3 <> TRUE)
    
            Data Elements:
    
            ^PMTPLN3 = PMTPLNSUB:INT:Declaration:Declaration.StatementAccepted.Indicator
    
            ^PMTPLN311 = PMTPLNSUB:INT:Declaration
            */
            assertion = (report.InT_DeclarationCollectionExists != false && report.PMTPLN3 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000013", Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:PMTPLNSUBRequest/tns:INT/tns:Declaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000013"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN3", Value = GetValueOrEmpty(report.PMTPLN3) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000013
    
            #region VR.ATO.PMTPLN.000015
    
            /*  VR.ATO.PMTPLN.000015
            If provided, Reporting Party Signature Indicator must be 'TRUE'
    
            Legacy Rule Format:
            (^PMTPLN312 <> NULL) AND (^PMTPLN9 <> TRUE)

            Technical Business Rule Format:
            (^PMTPLN312 <> NULL) AND (^PMTPLN9 <> TRUE)
    
            Data Elements:
    
            ^PMTPLN9 = PMTPLNSUB:RP:Declaration:Declaration.StatementAccepted.Indicator
    
            ^PMTPLN312 = PMTPLNSUB:RP:Declaration
            */
            assertion = (report.RP_DeclarationCollectionExists != false && report.PMTPLN9 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000015", Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:Declaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000015"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN9", Value = GetValueOrEmpty(report.PMTPLN9) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000015
    
            #region VR.ATO.PMTPLN.000016
    
            /*  VR.ATO.PMTPLN.000016
            (The declaration must be provided by the sender.) If the sender is the Reporting Party then the declaration must be provided by Reporting Party
    
            Legacy Rule Format:
            (^PMTPLN300 = NULL) AND (^PMTPLN312 = NULL)

            Technical Business Rule Format:
            (^PMTPLN300 = NULL) AND (^PMTPLN312 = NULL)
    
            Data Elements:
    
            ^PMTPLN300 = PMTPLNSUB:INT
    
            ^PMTPLN312 = PMTPLNSUB:RP:Declaration
            */
            assertion = (report.IntCollectionExists == false && report.RP_DeclarationCollectionExists == false);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000016", Severity = ProcessMessageSeverity.Error,
                    Description = @"The sender's Declaration is not provided.",
                    LongDescription = @"The Declaration must be provided by the Reporting Party.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:Declaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000016"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000016
    
            #region VR.ATO.PMTPLN.000020
    
            /*  VR.ATO.PMTPLN.000020
            The Australian Business Number (ABN) of the Client must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^PMTPLN6 <> NULL) AND (FailsABNAlgorithm(^PMTPLN6))

            Technical Business Rule Format:
            (^PMTPLN6 <> NULL) AND (FailsABNAlgorithm(^PMTPLN6))
    
            Data Elements:
    
            ^PMTPLN6 = PMTPLNSUB:RP:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.PMTPLN6 != null && FailsABNAlgorithm(report.PMTPLN6));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000020", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client ABN is invalid.",
                    LongDescription = @"The Australian Business Number (ABN) of the Client has failed the algorithm check.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000020"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN6", Value = GetValueOrEmpty(report.PMTPLN6) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000020
    
            #region VR.ATO.PMTPLN.000021
    
            /*  VR.ATO.PMTPLN.000021
            The Withholding Payer Number (WPN) of the Client must pass the WPN algorithm check.
    
            Legacy Rule Format:
            (^PMTPLN7<> NULL) AND (FailsWPNAlgorithm(^PMTPLN7))

            Technical Business Rule Format:
            (^PMTPLN7<> NULL) AND (FailsWPNAlgorithm(^PMTPLN7))
    
            Data Elements:
    
            ^PMTPLN7 = PMTPLNSUB:RP:Identifiers.WithholdingPayerNumber.Identifier
            */
            assertion = (report.PMTPLN7 != null && FailsTFNAlgorithm(report.PMTPLN7));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000021", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client WPN is invalid.",
                    LongDescription = @"The Withholding Payer Number (WPN) of the Client has failed the algorithm check.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:WithholdingPayerNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000021"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN7", Value = GetValueOrEmpty(report.PMTPLN7) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000021
    
            #region VR.ATO.PMTPLN.000022
    
            /*  VR.ATO.PMTPLN.000022
            The Australian Business Number (ABN) of the Registered agent must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^PMTPLN1 <> NULL) AND (FailsABNAlgorithm(^PMTPLN1))

            Technical Business Rule Format:
            (^PMTPLN1 <> NULL) AND (FailsABNAlgorithm(^PMTPLN1))
    
            Data Elements:
    
            ^PMTPLN1 = PMTPLNSUB:INT:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.PMTPLN1 != null && FailsABNAlgorithm(report.PMTPLN1));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000022", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent ABN is invalid.",
                    LongDescription = @"The Australian Business Number (ABN) of the Registered agent has failed the algorithm check.",
                    Location = "/tns:PMTPLNSUBRequest/tns:INT/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000022"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN1", Value = GetValueOrEmpty(report.PMTPLN1) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000022
    
            #region VR.ATO.PMTPLN.000023
    
            /*  VR.ATO.PMTPLN.000023
            The Registered Agent Number (RAN) must pass the Tax Agent Number (TAN) algorithm check.
    
            Legacy Rule Format:
            (^PMTPLN2 <> NULL) AND (((Length(^PMTPLN2) =7) AND (FailsTANAlgorithm(Concat('0', ^PMTPLN2)))) OR ((Length(^PMTPLN2) =8) AND (FailsTANAlgorithm(^PMTPLN2))))

            Technical Business Rule Format:
            (^PMTPLN2 <> NULL) AND (((Length(^PMTPLN2) =7) AND (FailsTANAlgorithm(Concat('0', ^PMTPLN2)))) OR ((Length(^PMTPLN2) =8) AND (FailsTANAlgorithm(^PMTPLN2))))
    
            Data Elements:
    
            ^PMTPLN2 = PMTPLNSUB:INT:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.PMTPLN2 != null && (Length(report.PMTPLN2) == 7 && FailsTANAlgorithm(string.Concat(@"0", report.PMTPLN2)) || Length(report.PMTPLN2) == 8 && FailsTANAlgorithm(report.PMTPLN2)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000023", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent RAN is invalid.",
                    LongDescription = @"The Registered Agent Number (RAN) has failed the algorithm check.",
                    Location = "/tns:PMTPLNSUBRequest/tns:INT/tns:TaxAgentNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000023"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN2", Value = GetValueOrEmpty(report.PMTPLN2) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000023
    
            #region VR.ATO.PMTPLN.000024
    
            /*  VR.ATO.PMTPLN.000024
            The Tax File Number (TFN) of the Client must pass the TFN algorithm check.
    
            Legacy Rule Format:
            (^PMTPLN5 <> NULL) AND (FailsTFNAlgorithm(^PMTPLN5))

            Technical Business Rule Format:
            (^PMTPLN5 <> NULL) AND (FailsTFNAlgorithm(^PMTPLN5))
    
            Data Elements:
    
            ^PMTPLN5 = PMTPLNSUB:RP:Identifiers.TaxFileNumber.Identifier
            */
            assertion = (report.PMTPLN5 != null && FailsTFNAlgorithm(report.PMTPLN5));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.PMTPLN.000024", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client TFN is invalid.",
                    LongDescription = @"The Tax File Number (TFN) of the Client has failed the algorithm check.",
                    Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000024"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "PMTPLN5", Value = GetValueOrEmpty(report.PMTPLN5) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.PMTPLN.000024

            #region Repeating report.RP_PaymentPlan_InstalmentCollection
            if (report.RP_PaymentPlan_InstalmentCollection != null)
            {    
                int itemIndex3 = 0;
                foreach (PMTPLNSUBRequest2020.RP_PaymentPlan_Instalment instalment in report.RP_PaymentPlan_InstalmentCollection)
                {
                    itemIndex3++;
            
                    #region VR.ATO.PMTPLN.000012
            
                    /*  VR.ATO.PMTPLN.000012
                    Instalment sequence number within the Instalment Container must be assigned sequentially beginning at 1, not exceed the number of instalments provided.
    
                    Legacy Rule Format:
                    (^PMTPLN28 = 0) OR(^PMTPLN28 > Count(^PMTPLN28))
        
                    Technical Business Rule Format:
                    (^PMTPLN28 = 0) OR(^PMTPLN28 > Count(^PMTPLN28))
            
                    Data Elements:
            
                    ^PMTPLN28 = PMTPLNSUB:RP:PaymentPlan:Instalment:PaymentRecord.Sequence.Number
                    */
                    assertion = (instalment.PMTPLN28 == 0 || instalment.PMTPLN28.GetValueOrDefault() > Count(report.RP_PaymentPlan_InstalmentCollection == null ? new List<decimal?>() : report.RP_PaymentPlan_InstalmentCollection.Select(f => f.PMTPLN28)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.PMTPLN.000012", Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid Instalment sequence number invalid.",
                            LongDescription = @"Instalment sequence number must start at 1; increment by 1 for each instalment; and must not exceed the number of instalments provided.",
                            Location = "/tns:PMTPLNSUBRequest/tns:RP/tns:PaymentPlan/tns:InstalmentCollection/tns:Instalment" + OccurrenceIndex(instalment.OccurrenceIndex) + "/tns:PaymentRecordSequenceN",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.PMTPLN.000012"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "PMTPLN28", Value = instalment.PMTPLN28.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.PMTPLN.000012
                    }
                }
        
                #endregion // Foreach loop

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
} 
